/* XDCtools wb_t@C */
#include <xdc/std.h>
#include <xdc/runtime/System.h>

/* BIOS wb_t@C */
#include <ti/sysbios/BIOS.h>
#include <ti/sysbios/knl/Task.h>
#include <ti/sysbios/knl/Clock.h>

/* hCowb_t@C */
#include <ti/drivers/GPIO.h>

/* {[hwb_t@C */
#include "Board.h"

/* GLCD wb_t@C */
#include "GLCD.h"

/* [U[`}N */
#define CONSOLE(...) do { System_printf(__VA_ARGS__); System_flush(); } while(0)
#define SLEEP(X) Task_sleep((X)*1000/Clock_tickPeriod)

/*
 * [U[^XN̗Dx
 */
#define TASK_LED_PRIO 1
#define TASK_GLCD_PRIO 9

/*
 * [U[X^bÑTCY
 */
#define TASK_LED_STACK 512
#define TASK_GLCD_STACK 512

/*
 * [U[^XN̍\
 */
Task_Struct taskLEDStruct;
Task_Struct taskGLCDStruct;

/*
 * [U[^XÑX^bN
 */
Char taskLEDStack[TASK_LED_STACK];
Char taskGLCDStack[TASK_GLCD_STACK];

/*
 * [U[^XN
 */

/*
 * LED _Ń^XN
 */
Void task_LED(UArg arg0, UArg arg1)
{
    CONSOLE("LED _Ń^XN̊Jn\n");

    // LED1 _
    GPIO_write(Board_LED0, Board_LED_ON);
    while (1)
    {

        // LED 0.5 bɃgO
        SLEEP(500);
        GPIO_toggle(Board_LED0);
    }
}

/*
 * GLCD \^XN
 */
Void task_GLCD(UArg arg0, UArg arg1)
{
    // \镶z`Ő錾
    char str_1[] = "ARM Challenger";
    char str_2[] = { 'A', 'D', 'W', 'I', 'N', '\0' };

    CONSOLE("GLCD \\ ^XN̊Jn\n");

    // eGLCD ɕ\
    GLCD_str(0, 0, "HELLO WORLD");
    GLCD_str(2, 0, str_1);
    GLCD_str(4, 0, str_2);

    while (1)
    {
        // ԑ҂
        SLEEP(1000);
    }
}

/*
 * C
 */

int main(void)
{
    Task_Params taskParams;

    // {[h̏ݒ
    CONSOLE(" {[h̏ݒ\n");
    Board_initGeneral();
    Board_initGPIO();

    // GLCD ̏
    GLCD_init();

    // [U[^XN̍쐬
    CONSOLE(" [U[^XN̍쐬\n");
    Task_Params_init(&taskParams);
    taskParams.stackSize = TASK_LED_STACK;
    taskParams.stack = &taskLEDStack;
    taskParams.priority = TASK_LED_PRIO;
    Task_construct(&taskLEDStruct, (Task_FuncPtr) task_LED, &taskParams, NULL);

    Task_Params_init(&taskParams);
    taskParams.stackSize = TASK_GLCD_STACK;
    taskParams.stack = &taskGLCDStack;
    taskParams.priority = TASK_GLCD_PRIO;
    Task_construct(&taskGLCDStruct, (Task_FuncPtr) task_GLCD, &taskParams, NULL);

    // OS ̋N
    CONSOLE("OS ̋N\n");
    BIOS_start();

    return (0);
}
