#include <stdbool.h>
#include <stdint.h>

#include <driverlib/gpio.h>
#include <driverlib/adc.h>
#include <driverlib/sysctl.h>
#include <inc/hw_memmap.h>

#include "ADC.h"

/* ADC̏ԁiADCsۂj */
volatile int adcCnvPrg;

/* ADCݒp\ */
typedef struct ADCPinConfig
{
    unsigned int port;
    unsigned int pin;
    unsigned int config;
} ADCPinConfig;

/* ADC̐ݒl */
ADCPinConfig adcPinConfig[ADC_PCOUNT] = {
    {
     .port = GPIO_PORTE_BASE, .pin = GPIO_PIN_4,
     .config = ADC_CTL_CH9 | ADC_CTL_IE | ADC_CTL_END
    },
    {
     .port = GPIO_PORTE_BASE,
     .pin = GPIO_PIN_5,
     .config = ADC_CTL_CH8 | ADC_CTL_IE | ADC_CTL_END
    }
};

/* ADC̏ */
void initADC(void)
{
    int i; // ėpJE^

    // ADCL
    SysCtlPeripheralEnable(SYSCTL_PERIPH_ADC0);

    // ADCƂĎgsADCɐݒ
    for (i = 0; i < ADC_PCOUNT; i++)
    {
        GPIOPinTypeADC(adcPinConfig[i].port, adcPinConfig[i].pin);
    }

    // ADCV[PX̐ݒ
    ADCSequenceConfigure(ADC0_BASE, 3, ADC_TRIGGER_PROCESSOR, 0);

    // ADCV[PX̗L
    ADCSequenceEnable(ADC0_BASE, 3);

    // adcCnvPrg̏
    adcCnvPrg = 0;

    // ŏ2ADCl͎̂Ă
    for(i=0;i<ADC_PCOUNT;i++)
    {
        getADC((ADC_Name)i);
        getADC((ADC_Name)i);
    }
}

/* ADCl̎擾 */
unsigned int getADC(ADC_Name adcPinName)
{
    uint32_t data;
    uint32_t pinVal;

    // ADCl擾Jn
    adcCnvPrg = 1;

    // PE4s̒lۑ
    pinVal = GPIOPinRead(GPIO_PORTE_BASE, GPIO_PIN_3);

    // PE4sLɂ
    GPIOPinWrite(GPIO_PORTE_BASE, GPIO_PIN_3, 0);

    // ADCV[PXXebv̐ݒ
    ADCSequenceStepConfigure(ADC0_BASE, 3, 0, adcPinConfig[adcPinName].config);

    // ADCJn
    ADCProcessorTrigger(ADC0_BASE, 3);

    // ADCI܂ő҂
    while (!ADCIntStatus(ADC0_BASE, 3, false))
        ;

    // ADCl擾
    ADCSequenceDataGet(ADC0_BASE, 3, &data);

    // PE4s̒lɖ߂
    GPIOPinWrite(GPIO_PORTE_BASE, GPIO_PIN_3, pinVal);

    // ADCl擾I
    adcCnvPrg = 0;
    return data;
}

/* ADC̏ԁiADCsۂj̎擾 */
int getADCStatus(void)
{
    return adcCnvPrg;
}
