/* XDCtools wb_t@C */
#include <xdc/std.h>
#include <xdc/runtime/System.h>

/* BIOS wb_t@C */
#include <ti/sysbios/BIOS.h>
#include <ti/sysbios/knl/Task.h>
#include <ti/sysbios/knl/Clock.h>

/* hCowb_t@C */
#include <ti/drivers/GPIO.h>

/* {[hwb_t@C */
#include "Board.h"

/* [U[`}N */
#define CONSOLE(...) do { System_printf(__VA_ARGS__); System_flush(); } while(0)
#define SLEEP(X) Task_sleep((X)*1000/Clock_tickPeriod)

/*
 * [U[^XN̗Dx
 */
#define TASK_LED_PRIO 1

/*
 * [U[X^bÑTCY
 */
#define TASK_LED_STACK 512

/*
 * [U[^XN̍\
 */
Task_Struct taskLEDStruct;

/*
 * [U[^XÑX^bN
 */
Char taskLEDStack[TASK_LED_STACK];

/*
 * [U[^XN
 */

/*
 * LED _Ń^XN
 */
Void task_LED(UArg arg0, UArg arg1)
{
    CONSOLE("LED _Ń^XN̊Jn\n");

    // LED1 _
    GPIO_write(Board_LED0, Board_LED_ON);
    while (1)
    {

        // LED 0.5 bɃgO
        SLEEP(500);
        GPIO_toggle(Board_LED0);
    }
}

/*
 * C
 */

int main(void)
{
    Task_Params taskParams;

    // {[h̏ݒ
    CONSOLE(" {[h̏ݒ\n");
    Board_initGeneral();
    Board_initGPIO();

    // [U[^XN̍쐬
    CONSOLE(" [U[^XN̍쐬\n");
    Task_Params_init(&taskParams);
    taskParams.stackSize = TASK_LED_STACK;
    taskParams.stack = &taskLEDStack;
    taskParams.priority = TASK_LED_PRIO;
    Task_construct(&taskLEDStruct, (Task_FuncPtr) task_LED, &taskParams, NULL);

    // OS ̋N
    CONSOLE("OS ̋N\n");
    BIOS_start();

    return (0);
}
