/* XDCtools wb_t@C */
#include <xdc/std.h>
#include <xdc/runtime/System.h>

/* BIOS wb_t@C */
#include <ti/sysbios/BIOS.h>
#include <ti/sysbios/knl/Task.h>
#include <ti/sysbios/knl/Clock.h>

/* C wb_t@C */
#include <stdio.h>

/* hCowb_t@C */
#include <ti/drivers/GPIO.h>
#include <ti/drivers/SDSPI.h>

/* NDK wb_t@C */
#include <ti/ndk/inc/netmain.h>

/* {[hwb_t@C */
#include "Board.h"

/* GLCD wb_t@C */
#include "GLCD.h"

/* [U[`}N */
#define CONSOLE(...) do { System_printf(__VA_ARGS__); System_flush(); } while(0)
#define SLEEP(X) Task_sleep((X)*1000/Clock_tickPeriod)

/*
 * [U[^XN̗Dx
 */
#define TASK_LED_PRIO 1
#define TASK_GLCD_PRIO 9
#define TASK_FATFS_PRIO 10
#define TASK_LDM_PRIO 11

/*
 * [U[X^bÑTCY
 */
#define TASK_LED_STACK 512
#define TASK_GLCD_STACK 512
#define TASK_FATFS_STACK 1024
#define TASK_LDM_STACK 512

/*
 * [U[^XN̍\
 */
Task_Struct taskLEDStruct;
Task_Struct taskGLCDStruct;
Task_Struct taskFATFSStruct;
Task_Struct taskLDMStruct;

/*
 * [U[^XÑX^bN
 */
Char taskLEDStack[TASK_LED_STACK];
Char taskGLCDStack[TASK_GLCD_STACK];
Char taskFATFSStack[TASK_FATFS_STACK];
Char taskLDMStack[TASK_LDM_STACK];

/*
 * [U[ϐ
 */
uint32_t IP;       // IPAhXi[pϐ
char lockSD;      // SDJ[hrpϐ
char toggleLDM;   // LDM̃gO
char charLDM;     // LDMɕ\镶

/*
 * [U[֐
 */

/*
 * CGI\[XR[hicontrol.cgij
 */
static int cgiControl(SOCKET s, int ContentLength, char *pArgs)
{
    char *buffer;
    char len;

    CONSOLE("CGIiRg[jJn\n");

    // obt@m
    buffer = (char*) mmBulkAlloc(ContentLength + 1);
    if (!buffer)
    {
        CONSOLE("obt@̊mۂɎs܂I\n");
        goto CGI_ERROR;
    }

    // POSTf[^擾
    len = recv(s, buffer, ContentLength, MSG_WAITALL);
    if (len < ContentLength)
    {
        CONSOLE("POSTf[^̎擾Ɏs܂I\n");
        goto CGI_ERROR;
    }
    buffer[ContentLength] = '\0';

    CONSOLE("POSTf[^:\n%s\n\n", buffer);

    // POSTf[^"toggle_LDM"̎ALDMON/OFF𔽓]
    if (strcmp(buffer, "toggle_LDM") == 0)
    {
        toggleLDM ^= 1;
    }

    // POSTf[^"changeChar_LDM"̎ALDM̕\ύX
    if (strcmp(buffer, "changeChar_LDM") == 0)
    {
        if (charLDM == 'A')
        {
            charLDM = 'B';
        }
        else
        {
            charLDM = 'A';
        }
    }

    httpSendStatusLine(s, HTTP_OK, CONTENT_TYPE_HTML);
    httpSendClientStr(s, CRLF);
    httpSendClientStr(s, "<!DOCTYPE html>\n"
                      "<html>\n"
                      "<head>\n"
                      "<meta charset='Shift_JIS'>\n"
                      "<title>WebT[õeXg</title>\n"
                      "</head>\n"
                      "<body>\n"
                      "CGĨeXg\n"
                      "</body>\n"
                      "</html>");

    CGI_ERROR:
    // obt@
    if (buffer)
        mmBulkFree(buffer);

    // 1Ԃ
    return 1;
}

/*
 * CGI\[XR[histatus.cgij
 */
static int cgiStatus(SOCKET s, int ContentLength, char *pArgs)
{
    char *buffer;
    char len;

    CONSOLE("CGIiԎ擾jJn\n");

    // obt@m
    buffer = (char*) mmBulkAlloc(ContentLength + 1);
    if (!buffer)
    {
        CONSOLE("obt@̊mۂɎs܂I\n");
        goto CGI_ERROR;
    }

    // POSTf[^擾
    len = recv(s, buffer, ContentLength, MSG_WAITALL);
    if (len < ContentLength)
    {
        CONSOLE("POSTf[^̎擾Ɏs܂I\n");
        goto CGI_ERROR;
    }
    buffer[ContentLength] = '\0';

    CONSOLE("POSTf[^:\n%s\n\n", buffer);

    // HTTPwb_̑M
    httpSendStatusLine(s, HTTP_OK, CONTENT_TYPE_HTML);
    httpSendClientStr(s, CRLF);

    // POSTf[^"get_sw"̎AĂXCb`ԐM
    if (strcmp(buffer, "get_sw") == 0)
    {
        // SW1Ă鎞̃eLXg
        if (GPIO_read(Board_BUTTON0) == 0)
        {
            httpSendClientStr(s, "PUSH SW1");
        }
    }

    CGI_ERROR:
    // obt@
    if (buffer) mmBulkFree(buffer);

    // 1Ԃ
    return 1;
}

/*
 * [U[^XN
 */

/*
 * LED_Ń^XN
 */
Void task_LED(UArg arg0, UArg arg1)
{
    CONSOLE("LED_Ń^XN̊Jn\n");

    // LED1_
    GPIO_write(Board_LED0, Board_LED_ON);

    while (1)
    {
        // LED 0.5bɃgO
        SLEEP(500);
        GPIO_toggle(Board_LED0);
    }
}

/*
 * GLCD\^XN
 */
Void task_GLCD(UArg arg0, UArg arg1)
{
    char IP_Address[16]; // IPAhX\pz

    CONSOLE("GLCD\\^XN̊Jn\n");

    // eGLCDɕ\
    GLCD_str(0, 5, "HTTP SERVER");
    GLCD_str(1, 0, "IP Address:");

    // IPAhX擾܂ő҂
    while (IP == 0) SLEEP(100);

    // IPAhX𕶎ɕϊ
    NtIPN2Str(IP, IP_Address);

    // IPAhXGLCDɕ\
    GLCD_str(2, 6, IP_Address);

    while (1)
    {
        // ԑ҂
        SLEEP(1000);
    }
}

/*
 * FATFS^XN
 */
Void task_FATFS(UArg arg0, UArg arg1)
{
    SDSPI_Handle sdspiHandle; // SDJ[h}Eg̃nh
    SDSPI_Params sdspiParams; // SDJ[h}Eg̃p[^

    FILE *fd; // t@CfBXNv^

    char readBuffer[128]; // t@Cǂݍ݃obt@
    unsigned int bytesRead; // t@Cǂݍ݃TCY

    CONSOLE("FATFS^XN̊Jn\n");

    // GLCDɕ\
    GLCD_str(6, 0, "Read text:");

    // ̃^XNSDJ[hgĂꍇ͎gI܂ő҂
    while (lockSD != 0) SLEEP(100);

    // SDJ[h̎gpJn
    lockSD = 1;

    // SDJ[h̐ݒp[^̏
    SDSPI_Params_init(&sdspiParams);

    // SDJ[h}Eg
    sdspiHandle = SDSPI_open(Board_SDSPI0, 0, &sdspiParams);

    // G[`FbN
    if (sdspiHandle == NULL)
    {
        CONSOLE("}EgɎs܂I\n");
        // GLCDɃG[bZ[W\
        GLCD_str(7, 0, "Mount error");
    }
    else
    {
        // t@CJ
        fd = fopen("fat:0:read.txt", "r");

        // G[`FbN
        if (fd == NULL)
        {
            CONSOLE("t@CJ܂łI\n");
            // GLCDɃG[bZ[W\
            GLCD_str(7, 0, "File open error");
        }
        else
        {
            // t@C當ǂݍ
            bytesRead = fread(readBuffer, 1, sizeof(readBuffer) -1, fd);
            readBuffer[bytesRead] = '\0';

            // GLCDɓǂݍ񂾕\
            GLCD_str(7, 0, readBuffer);

            // t@C
            fclose(fd);
        }

        // SDJ[h~
        SDSPI_close(sdspiHandle);
    }

    // SDJ[h̎gpI
    lockSD = 0;

    while (1)
    {
        // ԑ҂
        SLEEP(1000);
    }
}

/*
 * LEDhbg}gNX^XN
 */
Void task_LDM(UArg arg0, UArg arg1)
{
    int i, j; // ėpJE^

    // LDMpsiAm[hj
    uint32_t LDM_A[] = { LDM_P1, LDM_P2, LDM_P3, LDM_P4, LDM_P5,LDM_P6, LDM_P7, LDM_P8 };

    // LDMpsiJ\[hj
    uint32_t LDM_C[] = { LDM_P9, LDM_P10, LDM_P11, LDM_P12, LDM_P13,LDM_P14, LDM_P15, LDM_P16 };

    // pJE^j0ɐݒ
    j = 0;
    while (1)
    {
        // S
        for (i = 0; i < 8; i++)
        {
            GPIO_write(LDM_A[i], 0);
            GPIO_write(LDM_C[i], 1);
        }

        // LEDhbg}gNX`ʂ̋x~
        if (toggleLDM != 1)
        {
            SLEEP(30);
            continue;
        }

        if (charLDM == 'A')
        {
            // uAv̕`
            GPIO_write(LDM_A[j], 1);
            switch (j)
            {
            case 0:
                GPIO_write(LDM_C[6], 0);
                GPIO_write(LDM_C[7], 0);
                break;
            case 1:
                GPIO_write(LDM_C[4], 0);
                GPIO_write(LDM_C[5], 0);
                break;
            case 2:
                GPIO_write(LDM_C[2], 0);
                GPIO_write(LDM_C[3], 0);
                GPIO_write(LDM_C[5], 0);
                break;
            case 3:
                GPIO_write(LDM_C[0], 0);
                GPIO_write(LDM_C[1], 0);
                GPIO_write(LDM_C[5], 0);
                break;
            case 4:
                GPIO_write(LDM_C[2], 0);
                GPIO_write(LDM_C[3], 0);
                GPIO_write(LDM_C[5], 0);
                break;
            case 5:
                GPIO_write(LDM_C[4], 0);
                GPIO_write(LDM_C[5], 0);
                break;
            case 6:
                GPIO_write(LDM_C[6], 0);
                GPIO_write(LDM_C[7], 0);
                break;
            case 7:
                break;
            }
        }
        else if (charLDM == 'B')
        {
            // uBv̕`
            GPIO_write(LDM_A[j], 1);
            switch (j)
            {
            case 0:
                break;
            case 1:
                GPIO_write(LDM_C[0], 0);
                GPIO_write(LDM_C[1], 0);
                GPIO_write(LDM_C[2], 0);
                GPIO_write(LDM_C[3], 0);
                GPIO_write(LDM_C[4], 0);
                GPIO_write(LDM_C[5], 0);
                GPIO_write(LDM_C[6], 0);
                GPIO_write(LDM_C[7], 0);
                break;
            case 2:
                GPIO_write(LDM_C[0], 0);
                GPIO_write(LDM_C[3], 0);
                GPIO_write(LDM_C[7], 0);
                break;
            case 3:
                GPIO_write(LDM_C[0], 0);
                GPIO_write(LDM_C[3], 0);
                GPIO_write(LDM_C[7], 0);
                break;
            case 4:
                GPIO_write(LDM_C[0], 0);
                GPIO_write(LDM_C[3], 0);
                GPIO_write(LDM_C[7], 0);
                break;
            case 5:
                GPIO_write(LDM_C[1], 0);
                GPIO_write(LDM_C[2], 0);
                GPIO_write(LDM_C[4], 0);
                GPIO_write(LDM_C[5], 0);
                GPIO_write(LDM_C[6], 0);
                break;
            case 6:
                break;
            case 7:
                break;
            }
        }

        j++;
        if (j > 8) j = 0;

        SLEEP(1);
    }
}

/*
 * tbN֐
 */

Void netIPAddrHook(IPN IPAddr, uint IfIdx, uint fAdd)
{
    /* IPAhX̎擾 */
    IP = IPAddr;
    CONSOLE("IPAhX: %x\n", IP);
}

Void addWebFiles()
{
    SDSPI_Handle sdspiHandle; // SDJ[h}Eg̃nh
    SDSPI_Params sdspiParams; // SDJ[h}Eg̃p[^

    FILE *fd; // t@CfBXNv^

    static char page[2048]; // y[Wf[^̓ǂݍ݃obt@
    unsigned int bytesRead; // t@Cǂݍ݃TCY

    // ̃^XNSDJ[hgĂꍇ͎gI܂ő҂
    while (lockSD != 0) SLEEP(100);

    // SDJ[h̎gpJn
    lockSD = 1;

    // SDJ[h̐ݒp[^̏
    SDSPI_Params_init(&sdspiParams);

    // SDJ[h}Eg
    sdspiHandle = SDSPI_open(Board_SDSPI0, 0, &sdspiParams);

    // G[`FbN
    if (sdspiHandle == NULL)
    {
        CONSOLE("}EgɎs܂I\n");
        // GLCDɃG[bZ[W\
        GLCD_str(7, 0, "Mount error");
    }
    else
    {
        // t@CJ
        fd = fopen("fat:0:index.htm", "r");
        // G[`FbN
        if (fd == NULL)
        {
            CONSOLE("t@CJ܂łI\n");
            // GLCDɃG[bZ[W\
            GLCD_str(7, 0, "File open error");
        }
        else
        {
            // t@C當ǂݍ
            bytesRead = fread(page, 1, sizeof(page) - 1, fd);
            page[bytesRead] = '\0';
            CONSOLE("ǂݍ񂾃oCg: %d/%d\n", bytesRead, sizeof(page) - 1);

            // t@C
            fclose(fd);
        }
        // SDJ[h~
        SDSPI_close(sdspiHandle);
    }
    // SDJ[h̎gpI
    lockSD = 0;

    /* Webt@C̒ǉ */
    efs_createfile("index.html", strlen(page), (UINT8 *) page);
    efs_createfile("control.cgi", 0, (UINT8 *) cgiControl);
    efs_createfile("status.cgi", 0, (UINT8 *) cgiStatus);
}

Void removeWebFiles()
{
    /* Webt@C̍폜 */
    efs_destroyfile("index.html");
    efs_destroyfile("control.cgi");
    efs_destroyfile("status.cgi");
}

/*
 * C
 */

int main(void)
{
    Task_Params taskParams;

    // {[h̏ݒ
    CONSOLE("{[h̏ݒ\n");
    Board_initGeneral();
    Board_initGPIO();
    Board_initEMAC();
    Board_initSDSPI();

    // GLCD̏
    GLCD_init();

    // [U[ϐ̏l̐ݒ
    IP = 0;
    lockSD = 0;
    toggleLDM = 1;
    charLDM = 'A';

    // [U[^XN̍쐬
    CONSOLE("[U[^XN̍쐬\n");
    Task_Params_init(&taskParams);
    taskParams.stackSize = TASK_LED_STACK;
    taskParams.stack = &taskLEDStack;
    taskParams.priority = TASK_LED_PRIO;
    Task_construct(&taskLEDStruct, (Task_FuncPtr) task_LED, &taskParams, NULL);

    Task_Params_init(&taskParams);
    taskParams.stackSize = TASK_GLCD_STACK;
    taskParams.stack = &taskGLCDStack;
    taskParams.priority = TASK_GLCD_PRIO;
    Task_construct(&taskGLCDStruct, (Task_FuncPtr) task_GLCD, &taskParams, NULL);

    Task_Params_init(&taskParams);
    taskParams.stackSize = TASK_FATFS_STACK;
    taskParams.stack = &taskFATFSStack;
    taskParams.priority = TASK_FATFS_PRIO;
    Task_construct(&taskFATFSStruct, (Task_FuncPtr) task_FATFS, &taskParams, NULL);

    Task_Params_init(&taskParams);
    taskParams.stackSize = TASK_LDM_STACK;
    taskParams.stack = &taskLDMStack;
    taskParams.priority = TASK_LDM_PRIO;
    Task_construct(&taskLDMStruct, (Task_FuncPtr) task_LDM, &taskParams, NULL);

    // OS̋N
    CONSOLE("OS̋N\n");
    BIOS_start();

    return (0);
}
